/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __COMPONENTS_H__
#define __COMPONENTS_H__

typedef struct _xml_dtc_caller xml_dtc_caller;

typedef struct _xml_dtc_component xml_dtc_component;

#include <resource.h>
#include <request.h>
#include <xml-dtc.h>
#include <libxml/tree.h>

#define XML_DTC_COMPONENT_STANDARD_DEF \
  void *_private; \
  xml_dtc_type *type; \
  char *name; \
  int links; \
  xml_dtc_resource *resource; \
  int (* handle) (xml_dtc_caller *, xml_dtc_request *)

struct _xml_dtc_component {
  XML_DTC_COMPONENT_STANDARD_DEF;
};

#define XML_DTC_CALLER_STANDARD_DEF \
  void *_private; \
  xml_dtc_type *type; \
  char *name; \
  int links; \
  xml_dtc_resource *resource; \
  int resolved; \
  union { \
    char *name; \
    xml_dtc_component *object; \
  } component; \
  int (*hook_before) (xml_dtc_caller *, xml_dtc_request *); \
  int (*hook_after) (xml_dtc_caller *, xml_dtc_request *); \
  xml_dtc_hash *params;

struct _xml_dtc_caller {
  XML_DTC_CALLER_STANDARD_DEF;
};

xml_dtc_hash *xml_dtc_handler_components_loop_callback(xml_dtc_handler *handler, xml_dtc_hash *handlers, xml_dtc_sitemap *sitemap, xmlNodePtr node);

#endif /* __COMPONENTS_H__ */
