/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __MAPPINGS_H__
#define __MAPPINGS_H__

#include <list.h>
#include <hash.h>

typedef struct _xml_dtc_mappings xml_dtc_mappings;

typedef enum { m_list, m_hash } xml_dtc_mappings_type;

struct _xml_dtc_mappings {
  xml_dtc_resource *resource;
  int len;
  void **list;
  xml_dtc_mappings_type *type;
};

int xml_dtc_mappings_free(xml_dtc_mappings *mappings);

xml_dtc_mappings *xml_dtc_mappings_new(const xml_dtc_resource *resource);

char *xml_dtc_resolve_mappings(xml_dtc_mappings *mappings, char *string);

xml_dtc_list *xml_dtc_mappings_new_list(xml_dtc_mappings *mappings);

xml_dtc_hash *xml_dtc_mappings_new_hash(xml_dtc_mappings *mappings);

int xml_dtc_mappings_destroy_last(xml_dtc_mappings *mappings);

#endif /* __MAPPINGS_H__ */
