/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __MODULES_H__
#define __MODULES_H__

#include <objects.h>
#include <xml-dtc.h>

#define XML_DTC_API_VERSION 20040310

typedef struct _xml_dtc_module xml_dtc_module;
struct _xml_dtc_module {
  void *_private;
  int API;
  char *name;
  int (*registr)(void);
  void (*close)(void);
};

#define XML_DTC_MODULE_STANDARD_STUFF \
  NULL, \
  XML_DTC_API_VERSION, \
  __FILE__

#endif /* __MODULES_H__ */
