/*
 * libxml-dtc provides an XML framework creation facilities
 * Copyright (C) 2003-2004 Mike Hommey <mh@glandium.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __OBJECTS_H__
#define __OBJECTS_H__

typedef struct _xml_dtc_object xml_dtc_object;

typedef int (*xml_dtc_object_free_callback) (xml_dtc_object *);

#define XML_DTC_OBJECT_STANDARD_DEF \
  void *_private; \
  xml_dtc_type *type; \
  char *name; \
  int links; \
  xml_dtc_resource *resource

typedef struct _xml_dtc_type xml_dtc_type;
struct _xml_dtc_type {
  char *name;
  int size;
  xml_dtc_object_free_callback free;
  xml_dtc_type *parent;
};

#include <resource.h>

struct _xml_dtc_object {
  XML_DTC_OBJECT_STANDARD_DEF;
};

xml_dtc_object *xml_dtc_object_new(const xml_dtc_resource *resource, const char *name, const char *type);

xml_dtc_object *xml_dtc_object_link(xml_dtc_object *object);

int xml_dtc_object_unlink(xml_dtc_object *object);

#endif /* __OBJECTS_H__ */
